routes/web.php
<?php
Route::get('/user', function () {
    return Auth()->user();
});

// Home Routes
Route::prefix('/')->namespace('Web\Home')->group(function () {
    Route::get('/', 'HomeController@index')->name('home');
    Route::get('articles', 'ArticleController@index')->name('articles.index');
    Route::get('articles/details/{article}', 'ArticleController@show')->where('article', '[0-9]+')->name('articles.show');
    Route::get('articles/details/{slug}', 'ArticleController@showBySlug')->name('articles.show-by-slug');
    Route::get('categories/{category}', 'CategoryController@show')->name('categories.show');
    Route::get('videos', 'VideoController@index')->name('videos.index');
    Route::get('videos/details/{video}', 'VideoController@show')->name('videos.show');
    Route::get('podcasts', 'PodcastController@index')->name('podcasts.index');
    Route::post('comments', 'CommentController@store')->name('comments.store');
    Route::post('comments/{comment}/reply', 'CommentController@reply_store')->name('comments.reply.store');
    Route::get('authors', 'AuthorController@index')->name('authors.index');
    Route::get('authors/{author}', 'AuthorController@show')->name('authors.show');
    Route::get('translators', 'TranslatorController@index')->name('translators.index');
    Route::get('translators/{translator}', 'TranslatorController@show')->name('translators.show');
    Route::get('socials', 'HomeController@socials')->name('socials');
    Route::get('post_box', 'HomeController@post_box')->name('post_box');
    Route::post('post_box', 'HomeController@post_box_store')->name('post_box.store');
    Route::get('search', 'SearchController@index')->name('search.index');
    Route::get('search/result', 'SearchController@search')->name('search.result');
});

// Admin Routes
Route::prefix('admin')->namespace('Web\Admin')->group(function () {
    // Admin Auth Routes
    Route::prefix('auth')->namespace('Auth')->group(function () {
        Route::get('/', 'LoginController@showLoginForm');
        Route::get('/login', 'LoginController@showLoginForm')->name('admin.login');
        Route::post('/login', 'LoginController@login');
        Route::post('/logout', 'LoginController@logout')->name('admin.logout');

        Route::post('/password/email', 'ForgotPasswordController@sendResetLinkEmail')->name('admin.password.request');
        Route::post('/password/reset', 'ResetPasswordController@reset')->name('admin.password.email');
        Route::get('/password/reset', 'ForgotPasswordController@showLinkRequestForm')->name('admin.password.reset');
        Route::get('/password/reset/{token}', 'ResetPasswordController@showResetForm');
    });

    Route::get('/login', function () {
        return redirect('admin/auth/login');
    });
    Route::get('/', function () {
        return redirect('admin/dashboard');
    });

    // Admin Dashboard Routes
    Route::prefix('/')->middleware('auth')->group(function () {
        Route::get('dashboard', 'DashboardController@index')->name('admin.dashboard');
        Route::post('articles/uploadimage', 'ArticleController@uploadimage');
        Route::resource('articles', 'ArticleController', ['as' => 'admin']);
        Route::resource('authors', 'AuthorController', ['as' => 'admin']);
        Route::resource('translators', 'TranslatorController', ['as' => 'admin']);
        Route::resource('categories', 'CategoryController', ['as' => 'admin']);
        Route::resource('tags', 'TagController', ['as' => 'admin']);
        Route::get('post_requests', 'PostRequestsController@index')->name('admin.post_requests.index');
        Route::get('post_requests/{post_request}', 'PostRequestsController@show')->name('admin.post_requests.show');
    });
});

app/Http/Controllers/Web/Admin/ArticleController.php
<?php

namespace App\Http\Controllers\Web\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use Image;
use Session;
use App\Models\Post;
use App\Models\Category;
use App\Models\Author;
use App\Models\Translator;
use App\Models\Comment;

class ArticleController extends Controller
{
    public function index()
    {
        $data = array(
            "articles" => Post::where('post_type', 'article')->with(['categories', 'tags', 'authors', 'translators', 'comments'])->orderBy('id', 'desc')->paginate(500)
        );
        return view("admin.articles.index", $data);
    }

    public function create()
    {
        $data = array(
            "categories" => Category::select('id', 'name')->where('status', 1)->get(),
            "authors" => Author::select('id', 'name')->active()->get(),
            "translators" => Translator::select('id', 'name')->where('status', 1)->get(),
        );
        return view("admin.articles.create", $data);
    }

    public function store(Request $request)
    {
        $article = new Post();
        $article->title = $request->input("title");
        $article->body = $request->input("body");
        $article->slug = $request->has('slug') && !empty($request->input("slug")) ? $this->createSlug($request->input("slug")) : $this->createSlug($request->input("title"));
        $article->status = $request->has('status') ? $request->input("status") : 1;
        $article->post_type = "article";
        if ($request->hasFile("thumbnail")) {
            $image = $request->file('thumbnail');
            $timestemp = time();
            //$featured_image = 'image_' . $timestemp . '.' . $image->getClientOriginalExtension();
            //$path = storage_path() . '/app/public/uploads/post/featured_image/' . $featured_image;

            $image_name = $timestemp . '.' . $image->getClientOriginalExtension();
            $path = public_path('storage/uploads/post/featured_image/') . 'image_' . $image_name;
            Image::make($image)->resize(800, null, function ($constraint) {
                $constraint->aspectRatio();
            })->save($path);

            //$thumbnail = 'thumb_' . $timestemp . '.' . $image->getClientOriginalExtension();
            //$path = storage_path() . '/app/public/uploads/post/thumbnail/' . $thumbnail;
            $path = public_path('storage/uploads/post/thumbnail/') . 'thumb_' . $image_name;
            Image::make($image)->fit(350, 240)->save($path);

            $article->thumbnail = $image_name;
        }

        if ($article->save()) {
            $article->categories()->sync($request->categories);
            //$request->has('categories') ? $article->categories()->sync($request->categories) : $article->categories()->attach(1);
            // $article->tag()->sync($request->tags);
            $article->authors()->sync($request->authors);
            $article->translators()->sync($request->translators);
            Session::flash('response', array('type' => 'success', 'message' => 'Post added successfully!'));
        } else {
            Session::flash('response', array('type' => 'error', 'message' => 'Something Went wrong!'));
        }
        return redirect(route("admin.articles.index"));
    }


    public function show(Post $post)
    {
        $data = array(
            "post" => Post::with(["categories", "tags"])->find($post->id)
        );
        return view("admin.articles.view", $data);
    }

    public function edit(Post $article)
    {
        $data = array(
            "article" => Post::with(["categories", "tags"])->find($article->id),
            "categories" => Category::select('id', 'name')->where('status', 1)->get(),
            "authors" => Author::select('id', 'name')->where('status', 1)->get(),
            "translators" => Translator::select('id', 'name')->where('status', 1)->get(),
        );
        return view("admin.articles.edit", $data);
    }

    public function update(Request $request, Post $article)
    {
        $article->title = $request->input("title");
        $article->body = $request->input("body");
        if ($request->has('slug') && $request->input("slug") != $article->slug) {
            $article->slug = !empty($request->input("slug")) ? $this->createSlug($request->input("slug")) : $this->createSlug($request->input("title"));
        }
        $article->status = ($request->has('status')) ? $request->input("status") : 1;
        $article->updated_at = date("Y-m-d h:m:s");
        if ($request->hasFile("thumbnail")) {
            $image = $request->file('thumbnail');
            $timestemp = time();
            //$featured_image = 'image_' . $timestemp . '.' . $image->getClientOriginalExtension();
            //$path = storage_path() . '/app/public/uploads/post/featured_image/' . $featured_image;

            $image_name = $timestemp . '.' . $image->getClientOriginalExtension();
            $path = public_path('storage/uploads/post/featured_image/') . 'image_' . $image_name;
            Image::make($image)->resize(800, null, function ($constraint) {
                $constraint->aspectRatio();
            })->save($path);

            //$thumbnail = 'thumb_' . $timestemp . '.' . $image->getClientOriginalExtension();
            //$path = storage_path() . '/app/public/uploads/post/thumbnail/' . $thumbnail;
            $path = public_path('storage/uploads/post/thumbnail/') . 'thumb_' . $image_name;
            Image::make($image)->fit(350, 240)->save($path);

            $article->thumbnail = $image_name;
        }
        if ($article->save()) {
            $article->categories()->sync($request->categories);
            //$request->has('categories') ? $article->categories()->sync($request->categories) : $article->categories()->attach(1);
            // $article->tag()->sync($request->tags);
            $article->authors()->sync($request->authors);
            $article->translators()->sync($request->translators);
            Session::flash('response', array('type' => 'success', 'message' => 'Post updated successfully!'));
        } else {
            Session::flash('response', array('type' => 'error', 'message' => 'Something Went wrong!'));
        }
        return redirect(route("admin.articles.index"));
    }

    public function destroy(Post $article)
    {
        $article = Post::with(['categories', 'tags', 'authors', 'translators', 'comments'])->find($article->id);

        foreach ($article->categories as $category) {
            $article->categories()->detach($category->id);
        }
        foreach ($article->tags as $tag) {
            $article->tags()->detach($tag->id);
        }

        foreach ($article->authors as $author) {
            $article->authors()->detach($author->id);
        }

        foreach ($article->translators as $translator) {
            $article->translators()->detach($translator->id);
        }
        Comment::where('post_id', $article->id)->delete();

        if ($article->delete()) {
            Session::flash('response', array('type' => 'success', 'message' => 'Post deleted successfully!'));
        } else {
            Session::flash('response', array('type' => 'error', 'message' => 'Something Went wrong!'));
        }
        return redirect(route("admin.articles.index"));
    }

    // public function uploadimage(Request $request)
    // {
    //     if ($request->hasFile("upload")) {
    //         $image = $request->file('upload');
    //         $filename = 'image_' . time() . '.' . $image->getClientOriginalExtension();
    //         //$path = storage_path() . '/app/public/uploads/article-image/' . $filename;
    //         $path = public_path('storage/uploads/post/post_image/') . $filename;
    //         Image::make($image)->resize(800, null, function ($constraint) {
    //             $constraint->aspectRatio();
    //         })->save($path);

    //         $image_url = url('/storage/uploads/post/post_image/' . $filename);
    //         echo '<script type="text/javascript">window.parent.CKEDITOR.tools.callFunction("' . $request->CKEditorFuncNum . '", "' . $image_url . '", "");</script>';
    //     }
    // }

    private function checkSlug($slug)
    {
        $all_slugs = Post::select('slug')->where('slug', 'like', $slug . '%')->get();

        if (!$all_slugs->contains('slug', $slug)) {
            return $slug;
        }
        $i = 1;
        while ($i++) {
            $new_slug = $slug . '-' . $i;
            if (!$all_slugs->contains('slug', $new_slug)) {
                return $new_slug;
            }
        }
    }

    private function createSlug($title)
    {
        $slug_text = Str::words($title, 15, '');
        return $this->checkSlug(mb_strtolower(preg_replace('/[ ,.@#$%^&*()_\/=]+/', '-', trim($slug_text)), 'UTF-8'));
    }



    public function uploadimage(Request $request)
    {
        if ($request->hasFile("image")) {
            $image = $request->file('image');
            $filename = 'image_' . time() . '.' . $image->getClientOriginalExtension();
            //$path = storage_path() . '/app/public/uploads/article-image/' . $filename;
            $path = public_path('storage/uploads/post/post_image/') . $filename;
            Image::make($image)->resize(800, null, function ($constraint) {
                $constraint->aspectRatio();
            })->save($path);

            $image_url = url('/storage/uploads/post/post_image/' . $filename);
            echo $image_url;
        }
    }
}

app/Http/Controllers/Web/Home/ArticleController.php
<?php

namespace App\Http\Controllers\Web\Home;

use App\Http\Controllers\Controller;
use App\Models\Post;
use Session;

class ArticleController extends Controller
{
    public function index()
    {
        $data = array(
            "articles" => Post::published()->article()->with(['categories', 'tags', 'authors', 'translators'])->get()
        );
        return view("home.articles.index", $data);
    }

    public function show(Post $article)
    {
        // increment view count
        $article->increment('views', 1);

        $data = array(
            'article' => Post::published()->with(['categories', 'tags', 'authors', 'translators', 'comments', 'comments.replies'])->findOrFail($article->id),
            "related_articles" => Post::published()->where('id', $article->id)->with(['authors'])->inRandomOrder()->take(4)->get()
        );
        //return $data;
        return view("home.articles.show", $data);
    }

    public function showBySlug($slug)
    {
        // Find post by slug
        $article = Post::published()->where('slug', $slug)->with(['categories', 'tags', 'authors', 'translators', 'comments', 'comments.replies'])->firstOrFail();

        // increment view count
        $article->increment('views', 1);

        $data = array(
            'article' => $article,
            "related_articles" => Post::published()->where('id', $article->id)->with(['authors'])->inRandomOrder()->take(4)->get()
        );
        return view("home.articles.show", $data);
    }
}

resources/views/admin/articles/create.blade.php
@extends('layouts.admin')
@section('title', 'Add Article')
@section('second-nav-bar')
<ul class="right hide-on-med-and-down">
    <li>
        <a href="{{url('admin/articles')}}">All Article</a>
    </li>
</ul>
<ul id="nav-mobile" class="sidenav">
    <li>
        <a href="{{url('admin/articles')}}">All Article</a>
    </li>
</ul>
<a href="#" data-target="nav-mobile" class="sidenav-trigger">
    <i class="material-icons">menu</i>
</a>
@endsection
@section('content')
<div class="card panel">
    <div class="panel-header">
        <span class="panel-title">Add New Article</span>
        <div class="actions">
            <a href="{{ url('admin/articles') }}" class="btn-flat">
                <i class="material-icons">close</i>
            </a>
        </div>
    </div>
    <div class="card-content">
        <div class="row">
            <form id="create-post" action="{{ route('admin.articles.store')}}" method="POST"
                enctype="multipart/form-data">
                @csrf
                <div class="col s9 pr-2">
                    <div class="row">
                        <div class="input-field outline col s12">
                            <input name="title" id="title" type="text" value="{{ old('title') }}"
                                class="@error('title') invalid @enderror" required autofocus>
                            <label for="title">{{ __('Title') }}</label>
                            @error('title')
                            <span class="helper-text red-text">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                    <div class="row">
                        <div class="input-field outline col s12">
                            <input name="slug" id="slug" type="text" value="{{ old('slug') }}"
                                class="@error('slug') invalid @enderror">
                            <label for="slug">{{ __('Slug URL') }}</label>
                            @error('slug')
                            <span class="helper-text red-text">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                    <div class="row">
                        <div class="col s12">
                            <div id="quill-editor"></div>
                            <input type="hidden" name="body">
                            @error('body')
                            <span class="helper-text red-text">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                </div>
                <div class="col s3">
                    <div class="row">
                        <div class="input-field outline col s12">
                            <select class="material-select" id="categories" name="categories">
                                @if(isset($categories) && count($categories))
                                <option disabled selected>{{ __('ক্যাটাগরি সিলেক্ট করুন') }}</option>
                                @foreach( $categories as $key => $category )
                                <option value="{{ $category->id }}">{{ $category->name }}</option>
                                @endforeach
                                @else
                                <option disabled selected>{{ __('কোন ক্যাটাগরি নেই') }}</option>
                                @endif
                            </select>
                            <label for="categories">{{ __('ক্যাটাগরি') }}</label>
                        </div>
                    </div>
                    <div class="row">
                        <div class="input-field outline col s12">
                            <select class="material-select" id="authors" name="authors">
                                @if(isset($authors) && count($authors))
                                <option disabled selected>{{ __('লেখক সিলেক্ট করুন') }}</option>
                                @foreach( $authors as $key => $author )
                                <option value="{{ $author->id }}">{{ $author->name }}</option>
                                @endforeach
                                @else
                                <option disabled selected>{{ __('কোন লেখক নেই') }}</option>
                                @endif
                            </select>
                            <label for="authors">{{ __('লেখক') }}</label>
                        </div>
                    </div>
                    <div class="row">
                        <div class="input-field outline col s12">
                            <select class="material-select" id="translators" name="translators">
                                @if(isset($translators) && count($translators))
                                <option disabled selected>{{ __('অনুবাদক সিলেক্ট করুন') }}</option>
                                @foreach( $translators as $key => $translator )
                                <option value="{{ $translator->id }}">{{ $translator->name }}</option>
                                @endforeach
                                @else
                                <option disabled selected>{{ __('কোন অনুবাদক নেই') }}</option>
                                @endif
                            </select>
                            <label for="translators">{{ __('অনুবাদক') }}</label>
                        </div>
                    </div>
                    <div class="row">
                        <div class="input-field col s12">
                            <div class="file-field">
                                <div class="thumb-preview">
                                    <img src="" alt="" id="preview" style="height: auto;
                                    width: 100%;">
                                </div>
                                <div class="btn-flat custom teal white-text btn-block center">
                                    <span>নির্বাচিত ছবি</span>
                                    <input type="file" name="thumbnail" id="thumbnail"
                                        onchange="document.getElementById('preview').src = window.URL.createObjectURL(this.files[0])">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="input-field col s12">
                    <button type="submit" class="btn custom teal waves-effect waves-light" name="action">
                        <i class="material-icons left">add</i> {{ __('পোস্ট করুন') }}
                    </button>
                </div>
            </form>
        </div>
    </div>
</div>
<!-- Main Quill library -->
<script src="https://cdn.quilljs.com/1.3.6/quill.js"></script>
<script src="https://cdn.quilljs.com/1.3.6/quill.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/quill-image-resize-module@3.0.0/image-resize.min.js"></script>

<!-- Theme included stylesheets -->
<link href="https://cdn.quilljs.com/1.3.6/quill.snow.css" rel="stylesheet">
<link href="https://cdn.quilljs.com/1.3.6/quill.bubble.css" rel="stylesheet">
<script>
    var quill = new Quill('#quill-editor', {
        theme: 'snow',
        modules: {
            toolbar: {
                container: [
                    [{
                        header: [1, 2, 3, 4, 5, 6, false]
                    }],
                    ['bold', 'italic', 'underline', 'strike'],
                    ['link', 'blockquote'],
                    ['image', 'video'],
                    [{
                        'align': []
                    }],
                    [{
                        'list': 'ordered'
                    }, {
                        'list': 'bullet'
                    }],
                    [{
                        'indent': '-1'
                    }, {
                        'indent': '+1'
                    }],
                    [{
                        'direction': 'rtl'
                    }],
                    [{
                        'color': []
                    }, {
                        'background': []
                    }]
                ],
                handlers: {
                    image: imageHandler
                }
            },

            imageResize: {
                modules: ['Resize', 'DisplaySize', 'Toolbar']
            }
        },
    });

    function imageHandler() {
        const input = document.createElement('input');
        input.setAttribute('type', 'file');
        input.setAttribute('accept', 'image/*')
        input.click();

        // Listen upload local image and save to server
        input.onchange = () => {
            const file = input.files[0];
            // file type is only image.
            if (/^image\//.test(file.type)) {
                const fd = new FormData();
                fd.append('image', file);

                const xhr = new XMLHttpRequest();
                xhr.open("POST", "{{ url('admin/articles/uploadimage?_token=' . csrf_token()) }}", true);
                xhr.onload = () => {
                    if (xhr.status === 200) {
                        // this is callback data: url
                        const url = xhr.responseText;
                        const range = quill.getSelection();
                        quill.insertEmbed(range.index, 'image', url);
                    } else {
                        alert('Image upload failed');
                    }
                };
                xhr.send(fd);
            } else {
                console.warn('You could only upload images.');
            }
        };
    }

</script>
<script>
    var form = document.getElementById("create-post");

    form.onsubmit = function () {
        console.log('aaa');
        return false;
    }

    form.onsubmit = function () {
        var body = document.querySelector('input[name=body]');
        body.value = JSON.stringify(quill.getContents());
        return true;
    }

</script>

<style>
    .ql-container strong {
        font-weight: bold;
    }

</style>
@endsection

resources/views/admin/articles/index.blade.php
@extends('layouts.admin')
@section('title', 'Articles')
@section('second-nav-bar')
<ul class="right hide-on-med-and-down">
    <li>
        <a href="{{url('admin/articles/create')}}">Add Article</a>
    </li>
</ul>
<ul id="nav-mobile" class="sidenav">
    <li>
        <a href="{{url('admin/articles/create')}}">Add Article</a>
    </li>
</ul>
<a href="#" data-target="nav-mobile" class="sidenav-trigger">
    <i class="material-icons">menu</i>
</a>
@endsection
@section('content')
<div class="card material-data-table">
    <div class="table-header">
        <span class="table-title">All Articles</span>
        <div class="actions">
            <a href="{{url('admin/articles/create')}}" class="btn-flat">
                <i class="material-icons">add</i>
            </a>
            <a href="JavaScript:Void(0);" class="search-toggle waves-effect btn-flat">
                <i class="material-icons">search</i>
            </a>
        </div>
    </div>
    <table class="datatable responsive-table">
        <thead>
            <tr>
                <th class="hide">{{ __('#') }}</th>
                <th>{{ __('Title') }}</th>
                <th>{{ __('Category') }}</th>
                <th>{{ __('Author') }}</th>
                <th>{{ __('Translator') }}</th>
                <th>{{ __('Status') }}</th>
                <th>{{ __('Created At') }}</th>
                <th>{{ __('Action') }}</th>
            </tr>
        </thead>
        <tbody>
            @foreach ($articles as $index => $article)
            <tr>
                <td class="hide">{{ $article->index }}</td>
                <td>{{ $article->title }}</td>
                <td>
                    @if(isset($article->categories[0]->name))
                    {{ $article->categories[0]->name }}
                    @else
                    {{ __('-') }}
                    @endif
                </td>
                <td>
                    @if(isset($article->authors[0]->name))
                    {{ $article->authors[0]->name }}
                    @else
                    {{ __('-') }}
                    @endif
                </td>
                <td>
                    @if(isset($article->translators[0]->name))
                    {{ $article->translators[0]->name }}
                    @else
                    {{ __('-') }}
                    @endif
                </td>
                <td>{{ $article->status }}</td>
                <td>
                    {{date('d-m-Y', strtotime($article->created_at))}}
                </td>
                <td>
                    <a href="{{ route('articles.show', $article->id) }}" target="_blank"
                        class="btn-floating btn-flat btn-small waves-effect waves-light primary mr-3">
                        <i class="material-icons">visibility</i>
                    </a>
                    <a href="{{ route('admin.articles.edit', $article->id) }}"
                        class="btn-floating btn-flat btn-small waves-effect waves-light primary mr-3">
                        <i class="material-icons">edit</i>
                    </a>
                    <form action="{{ route('admin.articles.destroy', $article->id) }}" method="POST"
                        style="display: inline-block;">
                        @csrf
                        @method('DELETE')
                        <button type="submit" class="btn-floating btn-flat btn-small waves-effect waves-light red"
                            onclick="return(confirm('Are you sure to delete?'))">
                            <i class="material-icons">delete</i>
                        </button>
                    </form>
                </td>
            </tr>
            @endforeach
        </tbody>
    </table>
</div>
@endsection